#include <windows.h>
#include <direct.h>
#include "seamless3d.h"
#include "gui.h"
#include "ms-gui.h"

#ifdef RECORD_SOUNDMOVIE

//#define NUM_NOTIFICATIONS  16
#define NUM_NOTIFICATIONS  2
#include <dsound.h>
#pragma   comment(lib,"dsound.lib")

extern HWND hWndMain;
int g_numOfChannels = 2; //1 = mono, 2 = stereo

bool g_realTimeAudioSynth = false;

extern Ptr<VideoControlPanel> g_vcp;
LPDIRECTSOUNDCAPTURE g_pDsd = 0; //direct sound capture
LPDIRECTSOUND8 g_playDsd = 0; //direct sound play
LPDIRECTSOUNDCAPTUREBUFFER g_pDSBuffer8 = 0;
LPDIRECTSOUNDBUFFER g_playDSBuffer8 = 0;

LPDIRECTSOUNDNOTIFY g_pDSNotify = 0;
DSBPOSITIONNOTIFY g_aPosNotify[NUM_NOTIFICATIONS + 1];
DWORD g_dwCaptureBufferSize = 0;
DWORD g_bufferNextOffset = 0;
DWORD g_dwNotifySize = 0;
HANDLE g_hNotificationEvent;
int g_fps = 25; //5 //standard
int g_numOfSeconds = 10;

int g_sampleRate = 48000; //44100;

//String g_mainFilename = "frame";
//String g_mainFilename = "C:\\Users\\thyme\\Documents\\march-vlog\\real-thyme\\frame";
String g_mainFilename;// = "C:\\Users\\thyme\\Documents\\march-vlog\\clip0005\\frame";

int g_counter = 0;
unsigned int g_remCounter = 0;
unsigned int g_numOfFrames = g_fps * g_numOfSeconds;
unsigned short int* g_frameBufferS = 0;
Pix24* g_frameBuffer = 0;
unsigned int g_frameSizeS = 0;
unsigned int g_frameSize = 0;
unsigned int g_frameBufferSLen = 0;
unsigned int g_frameBufferLen = 0;
extern Ptr<_3DWin> g_3d;
void createPNG24(const char* filename, int width, int height, Pix24* pixels);
bool g_recordSoundMovie = false; //true = single shot
bool g_playSoundMovie = false;


extern bool mouse3dMode;
extern bool g_viewPosDragMode;
extern bool g_viewRotDragMode;
extern bool g_viewZRotDragMode;
short int* g_playBuf = 0;
int g_playBufLen = 0;
int g_playBufferIndex = 0;
bool g_playing = false;


void updateBuffer(){
	VOID*   lockedBuffer    = NULL;
	DWORD   lockedBufferLen;
	VOID*   lockedBuffer2   = NULL;
	DWORD   lockedBufferLen2;
	DWORD   dwReadPos;
	DWORD   dwCapturePos;

	if(NULL == g_pDSBuffer8){
		return;
	}
	if(g_frameBuffer == 0){
		return;
	}
	g_remCounter = g_counter;

	g_pDSBuffer8->GetCurrentPosition(&dwCapturePos, &dwReadPos);

	LONG lLockSize = dwReadPos - g_bufferNextOffset;
	if(lLockSize < 0){
		lLockSize += g_dwCaptureBufferSize;
	}

	lLockSize -= (lLockSize % g_dwNotifySize);

	static int f = 0;
	if(++f == 16){
		int a = 0;
	}

	if(lLockSize == 0){
		return;
	}
	//dLog((int)lLockSize);

	g_pDSBuffer8->Lock(g_bufferNextOffset, lLockSize, &lockedBuffer, &lockedBufferLen, &lockedBuffer2, &lockedBufferLen2, 0L);
	g_bufferNextOffset += lockedBufferLen + lockedBufferLen2;
	g_bufferNextOffset %= g_dwCaptureBufferSize;
	//dLog((int)(lockedBufferLen + lockedBufferLen2));
	//dLog((int)g_bufferNextOffset);

	unsigned short int* _lockedBuffer = reinterpret_cast<unsigned short int*>(lockedBuffer);
	unsigned short int* _lockedBuffer2 = reinterpret_cast<unsigned short int*>(lockedBuffer2);

	unsigned int s = 0;
	for(unsigned int lockedBufferLenInt = lockedBufferLen / 2; s < lockedBufferLenInt;){

		unsigned short int* dest = &g_frameBufferS[g_counter * g_frameSizeS];
		for(unsigned int i = 0; i < g_frameSizeS; i++, s++){
			dest[i] = _lockedBuffer[s];
		}
		if(++g_counter == g_numOfFrames){
			g_counter = 0;
		}
	}

	if(lockedBuffer2){
		s = 0;
		for(unsigned int lockedBufferLenInt = lockedBufferLen2 / 2; s < lockedBufferLenInt;){

			unsigned short int* dest = &g_frameBufferS[g_counter * g_frameSizeS];
			for(unsigned int i = 0; i < g_frameSizeS; i++, s++){
				dest[i] = _lockedBuffer2[s];
			}
			if(++g_counter == g_numOfFrames){
				g_counter = 0;
			}
		}
	}

	g_pDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);
}

void initSoundCapture(){
	g_frameSizeS = g_sampleRate / g_fps;
	g_dwNotifySize = g_frameSizeS * 2;
	g_frameSize = g_3d->size.x * g_3d->size.y;
	g_frameBufferLen = g_frameSize * g_numOfFrames;
	g_frameBufferSLen = g_frameSizeS * g_numOfFrames;
	g_frameBufferS = new unsigned short int[g_frameBufferSLen];
	g_frameBuffer = new Pix24[g_frameBufferLen];

	g_hNotificationEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	if(S_OK != DirectSoundCaptureCreate8((LPGUID)&DSDEVID_DefaultCapture, &g_pDsd, NULL)){
		return;
	}

	WAVEFORMATEX wfxInput;
	wfxInput.cbSize = 0;
	wfxInput.nBlockAlign = 2;
	wfxInput.nChannels = 1;
	wfxInput.nSamplesPerSec = g_sampleRate;
	wfxInput.nAvgBytesPerSec = wfxInput.nSamplesPerSec * 2;
	wfxInput.wBitsPerSample = 16;
	wfxInput.wFormatTag = 1;


	g_dwCaptureBufferSize = g_dwNotifySize * NUM_NOTIFICATIONS;

	DSCBUFFERDESC dsbd;
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	//dsbd.dwFlags = DSBCAPS_GLOBALFOCUS | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_GETCURRENTPOSITION2;
	dsbd.lpwfxFormat = &wfxInput; // Set the format during creatation
	dsbd.dwBufferBytes = g_dwCaptureBufferSize;

	g_pDsd->CreateCaptureBuffer(&dsbd, &g_pDSBuffer8, NULL);//2
	//g_pDSBuffer8->QueryInterface(IID_IDirectSoundBuffer8,(LPVOID*)&g_pDSBuffer8);

	g_bufferNextOffset = 0;

	//g_pDSBuffer8->Release();
	g_hNotificationEvent = CreateEvent( NULL, FALSE, FALSE, NULL);

	g_pDSBuffer8->QueryInterface( IID_IDirectSoundNotify, (VOID**)&g_pDSNotify);//3 and 4

	//	g_pDSNotify->Release();

	for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
		g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
		g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
	}

	g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5

	g_pDSBuffer8->Start(DSCBSTART_LOOPING); //6
}


void initPlaySound(){
	g_playBufferIndex = 0;
	g_frameSizeS = g_sampleRate / g_fps;
	g_dwNotifySize = g_frameSizeS * 2;
	g_frameSize = g_3d->size.x * g_3d->size.y;
	g_frameBufferLen = g_frameSize * g_numOfFrames;
	g_frameBufferSLen = g_frameSizeS * g_numOfFrames;
	g_frameBufferS = new unsigned short int[g_frameBufferSLen];

	g_hNotificationEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	if(S_OK != DirectSoundCreate8(NULL, &g_playDsd, NULL)){
		return;
	}
	if(S_OK != g_playDsd->SetCooperativeLevel(hWndMain, DSSCL_NORMAL)){
		return;
	}

	WAVEFORMATEX wfxInput;
	wfxInput.cbSize = 0;
	wfxInput.nBlockAlign = 2;
	wfxInput.nChannels = 2;
	wfxInput.nSamplesPerSec = g_sampleRate;
	wfxInput.nAvgBytesPerSec = wfxInput.nSamplesPerSec * 2;
	wfxInput.wBitsPerSample = 16;
	wfxInput.wFormatTag = 1;


	g_dwCaptureBufferSize = g_dwNotifySize * NUM_NOTIFICATIONS;


	DSBUFFERDESC dsbd;
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	dsbd.dwFlags = DSBCAPS_GLOBALFOCUS | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_GETCURRENTPOSITION2;
	dsbd.lpwfxFormat = &wfxInput; // Set the format during creatation
	dsbd.dwBufferBytes = g_dwCaptureBufferSize;

	g_playDsd->CreateSoundBuffer(&dsbd, &g_playDSBuffer8, NULL);
	//g_pDSBuffer8->QueryInterface(IID_IDirectSoundBuffer8,(LPVOID*)&g_pDSBuffer8);

	g_bufferNextOffset = 0;

	//g_pDSBuffer8->Release();
	g_hNotificationEvent = CreateEvent( NULL, FALSE, FALSE, NULL);

	g_playDSBuffer8->QueryInterface( IID_IDirectSoundNotify, (VOID**)&g_pDSNotify);//3 and 4

	//	g_pDSNotify->Release();

	for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
		g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
		g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
    }

	g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5

	
}
/*
void paintCross(int x, int y, int dstWidth, int dstHeight, Pix24* dstPix){
	x -= 11;
	int iconWidth = 24;
	int iconHeight = 24;

	if(x > dstWidth - iconWidth){
		iconWidth = dstWidth - x;
	}
	
	int idx = y * dstWidth + x;

	for(int i = iconWidth; --i >=0;){
		Pix24 pixel = dstPix[idx];
		pixel.r ^= 0xff;
		pixel.g ^= 0xff;
		pixel.b ^= 0xff;
		dstPix[idx] = pixel;
		idx++;
	}

	x += 11;
	y -= 11;
	if(y > dstHeight - iconHeight){
		iconHeight = dstHeight - y;
	}

	idx = y * dstWidth + x;

	for(int i = 11; --i >=0;){
		Pix24 pixel = dstPix[idx];
		pixel.r ^= 0xff;
		pixel.g ^= 0xff;
		pixel.b ^= 0xff;
		dstPix[idx] = pixel;
		idx += dstWidth;
	}
	idx += dstWidth;
	for(int i = 11; --i >=0;){
		Pix24 pixel = dstPix[idx];
		pixel.r ^= 0xff;
		pixel.g ^= 0xff;
		pixel.b ^= 0xff;
		dstPix[idx] = pixel;
		idx += dstWidth;
	}
}
*/

extern int g_clipCounter;
extern int g_frame;

void saveScreenshotToMem(unsigned int* pBits, unsigned int screenWidth, unsigned int width, unsigned int height, Pix24* lpDest){

	//if(g_clipCounter == 1 && g_frame == 300){
	//	int c = 0;
	//}

	for(unsigned int r = 0; r < height; r++){
		for(unsigned int c = 0; c < width; c++){
			int idx = r * width + c;
			unsigned int rawPix = pBits[r * screenWidth + c];
			Pix24 pixel;
			pixel.b = rawPix & 0x00ff;
			rawPix >>= 8;
			pixel.g = rawPix & 0x00ff;
			rawPix >>= 8;
			pixel.r = rawPix & 0x00ff;
			lpDest[idx] = pixel;
		}
	}
	if(g_settings->screenshotMouse && g_currentType2){
		if(g_viewPosDragMode || g_viewRotDragMode || g_viewZRotDragMode){
			pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 16, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
		}
		else if(mouse3dMode == false){
			if(g_currentType2 == g_crossCursor){
				pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 16, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
			}
			else if(g_currentType2 == g_lockedOnPointCursor){
				pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 12, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
			}
			else if(g_currentType2 == g_insertLineCursor){
				pasteSprite(g_mousePos.x - 2, g_mousePos.y - 30, 32 * 3, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_knifeCursor){
				pasteSprite(g_mousePos.x - 2, g_mousePos.y - 30, 32 * 3, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addGeometryCursor){
				//pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 16, 281, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
				pasteSprite(g_mousePos.x - 16, g_mousePos.y - 13, 32 * 2, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addGeometryMirrorCursor){
				//pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 15, 281, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
				pasteSprite(g_mousePos.x - 16, g_mousePos.y - 13, 32 * 1, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addPointCursor){
				pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 14, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
			}
			else if(g_currentType2 == g_ringSelectCursor){
				pasteSprite(g_mousePos.x - 7, g_mousePos.y - 7, 32 * 0, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addBoneCursor){
				pasteSprite(g_mousePos.x - 7, g_mousePos.y - 7, 32 * 4, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_insertBoneCursor){
				pasteSprite(g_mousePos.x - 7, g_mousePos.y - 7, 32 * 5, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else{
				pasteSprite(g_mousePos.x, g_mousePos.y, 469, 209, width, height, iconSrcBufCX, iconSrcBufCY, 11, 21, lpDest);
			}
		}
	}
}

void saveFrameToMem(unsigned int* pBits, unsigned int screenWidth, unsigned int width, unsigned int height){
	if(g_frameBuffer == 0){
		return;
	}
	int numOfFrams = g_counter - g_remCounter;
	if(numOfFrams < 0){
		numOfFrams += g_numOfFrames;
	}
	for(int k = numOfFrams; --k >= 0;){

		Pix24* lpDest = &g_frameBuffer[g_remCounter * g_frameSize];
		saveScreenshotToMem(pBits, screenWidth, width, height, lpDest);

		g_remCounter++;
		if(g_remCounter == g_numOfFrames){
			g_remCounter = 0;
		}
	}
}

#endif

extern const String g_screenshotDir;

void saveMemToFiles(unsigned int width, unsigned int height){
	SYSTEMTIME ToDaySystemTime;

	GetLocalTime(&ToDaySystemTime);
	char tmpChar[0x200];
	ToDaySystemTime.wYear -= 2000;
	sprintf(tmpChar,"%.2i%.2i%.2i_%.2i%.2i%.2i\\",ToDaySystemTime.wYear, ToDaySystemTime.wMonth, ToDaySystemTime.wDay, ToDaySystemTime.wHour,ToDaySystemTime.wMinute, ToDaySystemTime.wSecond);
	String folder = g_screenshotDir;
	folder += tmpChar;
	mkdir(folder.c_str());
	folder += g_mainFilename;

	String cntrStr;

	for(unsigned int k = 0; k < g_numOfFrames; k++, g_counter++){
		
		if(g_counter == g_numOfFrames){
			g_counter = 0;
		}

		Pix24* pixels = &g_frameBuffer[g_counter * g_frameSize];

		String filename = folder;

		cntrStr = static_cast<int>(k);
		while(cntrStr.length < 4){
			cntrStr = '0' + cntrStr;
		}
		filename += cntrStr;

		filename += ".png";

		createPNG24(filename.c_str(), width, height, pixels);

		//save pcm
		//filename = folder;

		//cntrStr = static_cast<int>(k);
		//while(cntrStr.length < 3){
		//	cntrStr = '0' + cntrStr;
		//}
		//filename += cntrStr;

		//filename += ".pcm";

		//FILE* stream = fopen(filename.c_str(), "w+b");
		//if(stream == 0){
		//	return;
		//}
		//unsigned short int* samples = &g_frameBufferS[g_counter * g_frameSizeS];
		//fwrite(samples, 2, g_frameSizeS, stream);
		//fclose(stream);
	}
}

void exitSoundCapture(){
	if(g_pDSNotify){
		g_pDSNotify->Release();
		g_pDSNotify = 0;
	}
	if(g_pDSBuffer8){
		g_pDSBuffer8->Release();
		g_pDSBuffer8 = 0;
	}
	if(g_pDsd){
		g_pDsd->Release();
		g_pDsd = 0;
	}
    // Release COM
	CoUninitialize();

	CloseHandle(g_hNotificationEvent);

	saveMemToFiles(g_3d->size.x, g_3d->size.y);

	delete[] g_frameBufferS;
	delete[] g_frameBuffer;
	g_frameBufferS = 0;
	g_frameBuffer = 0;
}


extern bool g_screenshotLate;
extern bool g_screenshotEarly;

void toggleRecordSoundMovie(){

	g_recordSoundMovie = !g_recordSoundMovie;

	if(g_recordSoundMovie){
		g_screenshotLate = false;
		g_screenshotEarly = false;
		if(g_settings->screenshotWindows){
			g_screenshotLate = true;
		}
		else{
			g_screenshotEarly = true;
		}
		initSoundCapture();
	}
	else{
		g_screenshotLate = false;
		g_screenshotEarly = false;
		exitSoundCapture();
	}
}

extern String g_currentFilename;
bool modifyWavFilename(String& filename);

void togglePlaySound(bool state, short int* ibuf, int bufLen){
	String filename = g_currentFilename;

	if(modifyWavFilename(filename)){
		int a = PlaySound(
			filename.c_str(),
			0,
			SND_ASYNC
		);
	}

	return;

	if(bufLen == 0){
		return;
	}
	g_playSoundMovie = state;

	if(g_playSoundMovie){
		if(g_playing == false){
			//for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
			//	g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
			//	g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
			//}

			//g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5
			//initPlaySound();


			g_playing = true;
			g_playBufferIndex = 0;
			g_bufferNextOffset = 0;
			//updatePlayBuffer();
			g_playDSBuffer8->Play(0, 0, DSBPLAY_LOOPING);
			//updatePlayBuffer();
		}
	}
	else{
		g_playDSBuffer8->Stop();
		g_playing = false;
		//exitPlaySound();
	}
}

void Anim::setUpSoundPlay(){
	if(soundTrack.length){
		if(Composition* composition = dynamic_cast<Composition*>(soundTrack.refValue()[0].p)){
			g_playBuf = composition->ibuf;
			g_playBufLen = composition->bufLen;
			g_playSoundMovie = true;
			initPlaySound();
		}
	}
}

WAVEFORMATEX wfxInput;

void removeFilename(String& str);
extern String g_currentFilename;



bool initDirectSound2(){
	if(g_realTimeAudioSynth){
		g_numOfChannels = 1;
	}
	g_mainFilename = g_currentFilename;
	removeFilename(g_mainFilename);
	g_mainFilename += "\\frame";


	//g_counter = 0;

	if(S_OK != DirectSoundCreate8(NULL, &g_playDsd, NULL)){
		return false;
	}
	if(S_OK != g_playDsd->SetCooperativeLevel(hWndMain, DSSCL_NORMAL)){
		return false;
	}

	WAVEFORMATEX wfxInput;
	wfxInput.cbSize = 0;
	wfxInput.nBlockAlign = 2 * g_numOfChannels;
	wfxInput.nChannels = g_numOfChannels;
	wfxInput.nSamplesPerSec = 48000; //44100;
	wfxInput.wBitsPerSample = 16;
	wfxInput.nAvgBytesPerSec = wfxInput.nSamplesPerSec * (wfxInput.wBitsPerSample / 8) * g_numOfChannels;
	wfxInput.wFormatTag = 1;

	if(g_realTimeAudioSynth){
		g_dwNotifySize = 1024;
	}
	else{
		g_dwNotifySize = wfxInput.nSamplesPerSec / g_fps * 2 * g_numOfChannels;
	}
	
	g_dwCaptureBufferSize = g_dwNotifySize * NUM_NOTIFICATIONS;


	DSBUFFERDESC dsbd;
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	dsbd.dwFlags = DSBCAPS_GLOBALFOCUS | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_GETCURRENTPOSITION2;
	dsbd.lpwfxFormat = &wfxInput; // Set the format during creatation
	dsbd.dwBufferBytes = g_dwCaptureBufferSize;

	int a = g_playDsd->CreateSoundBuffer(&dsbd, &g_playDSBuffer8, NULL);
	//g_playDSBuffer8->QueryInterface(IID_IDirectSoundBuffer8,(LPVOID*)&g_playDSBuffer8);
	if(a == DSERR_ALLOCATED){
		int b = 0;
	}
	else if(a == DSERR_BADFORMAT){
		int b = 0;
	}
	else if(a == DSERR_BUFFERTOOSMALL){
		int b = 0;
	}
	else if(a == DSERR_CONTROLUNAVAIL){
		int b = 0;
	}
	else if(a == DSERR_DS8_REQUIRED){
		int b = 0;
	}
	else if(a == DSERR_INVALIDCALL){ 
		int b = 0;
	}
	else if(a == DSERR_INVALIDPARAM){ 
		int b = 0;
	}
	else if(a == DSERR_NOAGGREGATION){ 
		int b = 0;
	}
	else if(a == DSERR_OUTOFMEMORY){
		int b = 0;
	}
	else if(a == DSERR_UNINITIALIZED){
		int b = 0;
	}
	else if(a == DSERR_UNSUPPORTED){
		int b = 0;
	}

	g_bufferNextOffset = 0;


	g_hNotificationEvent = CreateEvent( NULL, FALSE, FALSE, NULL);

	g_playDSBuffer8->QueryInterface(IID_IDirectSoundNotify,(LPVOID*)&g_pDSNotify);

	for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
		g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
		g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
    }

	g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5
	return true;
}

bool initDirectSound(){
	g_bufferNextOffset = 0;


	initDirectSound2();


	if(DS_OK == g_playDSBuffer8->SetCurrentPosition(0)){
		g_playDSBuffer8->Play(0, 0, DSBPLAY_LOOPING);
	}
	return true;
}
bool freeDirectSound(){
//8
	if(g_pDSNotify){
		g_pDSNotify->Release();
		g_pDSNotify = 0;
	}
	if(g_playDsd){
		g_playDsd->Release();
		g_playDsd = 0;
	}
	if(g_pDSBuffer8){
		g_playDSBuffer8->Release();
		g_playDSBuffer8 = 0;
	}
    // Release COM
    CoUninitialize();
	g_playSoundMovie = false;

    return true;
}


bool stopDirectSound(){
	bool ret = DS_OK == g_playDSBuffer8->Stop();

	freeDirectSound();

    return ret;
}


String cntrStr;
extern Ptr<AnimControlPanel> g_acp;
extern int g_animBarListIndex;


int g_aTime = 0;
float g_prevAmp = 0;

void synthBuffer(short int* buffer, int bufferLen){
	float amp = 1.0f - static_cast<float>(g_mousePos.y) / static_cast<float>(720);

	//float peakFreq = 1.0f - static_cast<float>(g_mousePos.x) / static_cast<float>(1280);
	int peakFreq = (g_mousePos.x - 100);

	float fnumOfSamples = bufferLen;
	int numOfHarmonics = 90;
	float volume = .5;

	double ampDiff = amp - g_prevAmp;

	for(int i = 0; i < bufferLen; i++){

		float level = ampDiff / fnumOfSamples * (i + 1) + g_prevAmp;

		float sample = 0;

		float m = 0;
		for(int h = 0; h < numOfHarmonics; h++){
			m += 1;
			int m2 = m * 32;
			if(m2 >= peakFreq - 192 && m2 <= peakFreq + 192){
				float pa = 0;
				if(m2 <= peakFreq){
					pa = 1.0 - float(peakFreq - m2) / 193.0f;
				}
				else if(m2 > peakFreq){
					pa = 1.0 - float(m2 - peakFreq) / 193.0f;
				}

				float f = static_cast<float>((g_aTime + 1) * h) / 220.0;
				float a = level * pa * (1.0f / m);
				sample += volume * a * sinf(f * PI * 2);
			}
		}



		buffer[i] = static_cast<short int>(sample * 0x7fff);
		g_aTime++;
	}

	g_prevAmp = amp;
}


void updatePlayBufferRealTimeSynth(){
	Anim* animA = g_scene->animBarList[g_animBarListIndex];

	VOID*   lockedBuffer    = NULL;
	DWORD   lockedBufferLen;
	VOID*   lockedBuffer2   = NULL;
	DWORD   lockedBufferLen2;
	DWORD   dwReadPos = 0;
	DWORD   dwCapturePos = 0;


	g_playDSBuffer8->Lock(g_bufferNextOffset, g_dwNotifySize, &lockedBuffer, &lockedBufferLen, &lockedBuffer2, &lockedBufferLen2, 0L);

	//fread(lockedBuffer, 1, lockedBufferLen, stream);
	synthBuffer(reinterpret_cast<short int*>(lockedBuffer), lockedBufferLen / 2);


	g_bufferNextOffset += lockedBufferLen; 
	g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer

	if(lockedBuffer2){
		synthBuffer(reinterpret_cast<short int*>(lockedBuffer2), lockedBufferLen2 / 2);
		g_bufferNextOffset += lockedBufferLen2; 
		g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer
	}

	g_playDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);


}

void updatePlayBuffer(){
	Anim* animA = g_scene->animBarList[g_animBarListIndex];

	VOID*   lockedBuffer    = NULL;
	DWORD   lockedBufferLen;
	VOID*   lockedBuffer2   = NULL;
	DWORD   lockedBufferLen2;
	DWORD   dwReadPos = 0;
	DWORD   dwCapturePos = 0;

	//String filename = g_mainFilename;
	String filename = g_vcp->video->path;
	cntrStr = g_counter;
	while(cntrStr.length < 5){
		cntrStr = "0" + cntrStr;
	}
	filename = filename + cntrStr;
	filename += ".pcm";
	FILE* stream = fopen(filename.c_str(), "rb");
	if(stream == 0){
		if(stopDirectSound()){
			animA->play = false;

			g_playSoundMovie = false;
			g_playing = false;
			Video::audioTimeMode = false;

			animA->slider.refValue() = 1;
			g_acp->paint();
			return;
		}
	}

//	g_playDSBuffer8->GetCurrentPosition(&dwCapturePos, &dwReadPos);
//
//	LONG lLockSize = dwReadPos - g_bufferNextOffset;
//	if(lLockSize < 0){
//		lLockSize += g_dwCaptureBufferSize;
//	}
//
//	lLockSize -= (lLockSize % g_dwNotifySize);
//
//	if(lLockSize == 0){
////		return;
//	}

	g_playDSBuffer8->Lock(g_bufferNextOffset, g_dwNotifySize, &lockedBuffer, &lockedBufferLen, &lockedBuffer2, &lockedBufferLen2, 0L);

	fread(lockedBuffer, 1, lockedBufferLen, stream);

	g_bufferNextOffset += lockedBufferLen; 
	g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer

	if(lockedBuffer2){
		fread(lockedBuffer2, 1, lockedBufferLen2, stream);

		g_bufferNextOffset += lockedBufferLen2; 
		g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer
	}

	g_playDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);
	fclose(stream);
	g_acp->paint();
	g_counter++;


	
	animA->slider.refValue() = static_cast<float>(g_counter) / g_fps / animA->period;

	int numOfFrames = static_cast<int>(animA->period * g_fps + .5);

	if(g_counter >= numOfFrames){
		if(g_animBarListIndex == g_scene->animBarList.length - 1){
			if(g_counter == numOfFrames + 1){//dont stop playing the audio untill the last frame in the last clip is done
				if(stopDirectSound()){
					animA->play = false;

					g_playSoundMovie = false;
					g_playing = false;
					Video::audioTimeMode = false;

					animA->slider.refValue() = 1;
					g_acp->paint();
				}
			}
		}
		else{
			g_animBarListIndex++;
			Anim* anim = g_scene->animBarList[g_animBarListIndex];
			g_acp->anim = anim;
			if(Video* video = dynamic_cast<Video*>(anim->video.p)){
				g_vcp->video = video;

				removeTypeFromList < Button>(g_callBackList);
				removeTypeFromList < DownButton>(g_callBackList);


				video->frame = 0;
				g_counter = 0;
				anim->slider.refValue() = 0;
				animA->play = false;
				anim->play = true;
				g_stw->paint();

				g_acp->timeLine->anim = anim;
				g_acp->timeLine->animCP = g_acp.p;

				g_acp->animSelect->anim = anim;
				g_acp->animSelect->animCP = g_acp.p;

				g_acp->animSlider->anim = anim;
				g_acp->animSlider->animCP = g_acp.p;

				g_acp->pauseButton->anim = anim;
				g_acp->pauseButton->animCP = g_acp.p;

				const M_Properties& properties = anim->getProperties();
				g_acp->loopButton = dynamic_cast<SFBoolButton*>(anim->loop.setUpControl(*anim, anim->loop, properties[5], 0, 340+24, 0, *g_acp.p));

				g_acp->animPeriod->anim = anim;

				g_acp->animPlayFrom->anim = anim;
				g_acp->animPlayFrom->animCP = g_acp.p;

				//g_acp->setupNodeWindow(anim);
			}
		}
	}

}
/*
void updatePlayBuffer(String& filename){
	VOID*   lockedBuffer    = NULL;
	DWORD   lockedBufferLen;
	VOID*   lockedBuffer2   = NULL;
	DWORD   lockedBufferLen2;
	DWORD   dwReadPos = 0;
	DWORD   dwCapturePos = 0;

	filename += ".pcm";
	FILE* stream = fopen(filename.c_str(), "rb");
	if(stream == 0){
		return;
	}

//	g_playDSBuffer8->GetCurrentPosition(&dwCapturePos, &dwReadPos);
//
//	LONG lLockSize = dwReadPos - g_bufferNextOffset;
//	if(lLockSize < 0){
//		lLockSize += g_dwCaptureBufferSize;
//	}
//
//	lLockSize -= (lLockSize % g_dwNotifySize);
//
//	if(lLockSize == 0){
////		return;
//	}

	g_playDSBuffer8->Lock(g_bufferNextOffset, g_dwNotifySize, &lockedBuffer, &lockedBufferLen, &lockedBuffer2, &lockedBufferLen2, 0L);

	fread(lockedBuffer, 1, lockedBufferLen, stream);

	g_bufferNextOffset += lockedBufferLen; 
	g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer

	if(lockedBuffer2){
		fread(lockedBuffer2, 1, lockedBufferLen2, stream);

		g_bufferNextOffset += lockedBufferLen2; 
		g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer
	}

	g_playDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);
	fclose(stream);
	g_counter++;
}
*/
