/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


extern HWND hChatWnd;

void paintChatWindow(HWND hWnd, HDC hdc);
extern M_<String> g_chatLines;
extern int g_beginYChatOffset;
extern int g_numOfVisChatLines;
void dLog(String str);
LRESULT WINAPI ChatWindowProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

extern String g_userName;
const short PORT = 7778;

bool initWinsock();
extern String g_IPNum;
BOOL CALLBACK userFieldsProc(HWND hDlg,UINT iMessage, WPARAM wParam, LPARAM lParam);

#define IDC_CHAT_NAME 0x1014
#define IDD_USER_FIELDS 0x1015


void getDlgItemString(HWND hDlg, int nIDDlgItem, String& value);
bool getIPAddress(String filename, String& IPAddy);

class ClientRequestToJoin{
	char instruction;
	String name;
	String avatarUrl;
};
class ServerReplyForJoin{
	char instruction;
	short int id;
	//any number of
	short int _id;
	String name;
	String avatarUrl;
	Rotation orientation;
	Vec3f position;
};
class NewClientJoined{
	char instruction;
	short int id;
	short int numOfOtherClients;
	String name;
	String avatarUrl;
};
class ClientLeft{
	char instruction;
	short int id;
};
class ChatFromClient{
	char instruction;
	short int id;
	String message;
};
class MessageFromServer{
	char instruction;
	String message;
};
class ClientOrientationPosition{
	char instruction;
	short int id;
	Rotation orientation;
	Vec3f position;
};
class ClientNavKey{
	char instruction;
	short int id;
	char keys;	//1=left 2=right 4=backward; 8=forward
};

extern bool g_leftKeyDown;
extern bool g_rightKeyDown;
extern bool g_backwardKeyDown;
extern bool g_forwardKeyDown;

extern double g_leftKeyTime;
extern double g_rightKeyTime;
extern double g_backwardKeyTime;
extern double g_forwardKeyTime;
//void doStringFromChat(int id);
void sendStringToChatThreadSafe(String str);
#define autoRepeatPeriod .33333333

class Gravity{
public:
	float landSquareSize;
	float halfLSS;
	float landTrans;
	int landStrips;
	int landEdgePntCnt;
	float oneDivByLandSquareSize;
	float landCXZ;

	NurbsPatch* land;
	Art* part;
	Gravity(NurbsPatch* land, Art* part, float landCXZ, int landStrips):
		land(land),
		part(part),
		landCXZ(landCXZ),
		landStrips(landStrips)
	{
		landEdgePntCnt = landStrips + 1;

		landSquareSize = landCXZ / landStrips;
		halfLSS = landSquareSize * .5;
		landTrans = landCXZ * .5;
		oneDivByLandSquareSize = 1 / landSquareSize;
	}
	void initialize();
	float getLandHeight(float x, float z);
};
extern Gravity g_gravity;
