/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#define _WIN32_WINNT 0x0410


#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include"robot_aid.h"
extern const char* Complete;

void InputEvent::preMultiCtrlPointEditDemo(){
	g_robotDemo->fileName="multi-control-point-edit.smls";
	g_robotDemo->function=InputEvent::multiCtrlPointEditDemo;
	g_robotDemo->name="Create a new seamless file";
	robotDemoStart(setupSequence);
}
void InputEvent::multiCtrlPointEditDemo(){
	InputEvent* eventArray[]={
		new Section("Create a new seamless file"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "multi-control-point-edit.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new Section("Create NURBS patch"),
		new ClickButton(buildAvSegmentForSelPart),
new ClickControlPoint(0),
new Move3d(0,-.65),
new ClickControlPoint(1),
new Move3d(.05,-.65),
new ClickControlPoint(4),
new Move3d(0,.95),
new ClickControlPoint(3),
new Move3d(.05,.95),

new AddCtrlPnt(.05,.55),
new AddCtrlPnt(.05,-.25),
new AddCtrlPnt(.05,-.45),
new AddCtrlPnt(.05,-.05),
new AddCtrlPnt(.05,.35),
new AddCtrlPnt(.05,.75),

new IncFieldX("bands",24),

new MoveToNode(4),
new RightClick,
new Move_MenuItem("convert to patch"),
new Click,

new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new IncFieldX("control_staves"),

new SelectNode(5),
new SelectNode(4),
new Section("Select points"),


new MoveToExitSceneTree(),
new Click(),
new ClickButton(toggleWireFrame),

new RectVert(-.25,1.009375,.2225,-.168124),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.005,-.053571,0)),

new Neutral(-.005,1.036428),

new Stretch(1.249999,-.053525),
//new RectVert(-.071875,.121875,.055625,-.220625),
new UnRectVert(.115625,.1375,1.273126,-.245),

new Rotate(.274079,.131429),
new TugCP(73,.022199,-.07094),

new Section("Stretch 2d"),
new RectVert(.403125,.215625,.585625,-.296875),

new Neutral(.47094,.086446),

new Scale2d(.46594,1.037017),


new Section("Stretch 1d"),
new RectVert(.84375,.15,.99625,-.2),
new Neutral(.922801,.086446),
new Scale1d(.922801,1.037017),

new DragViewRot(.153118,-.988153,-.010423,2.203848),
new DragViewRot(-.113866,-.982535,-.147172,.282697),
new ClickButton(setFrontViewOrientation),

new Section("Scale 3d"),
new RectVert(-.40625,.621875,1.223751,-.773125),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.082985,-.65862,0)),

new Scale3d(141,1.575514,1.010445),
new Scale3d(141,.405709,-.166812),

new Section(Complete),
	};
	list+=EVENT_LIST(eventArray);
}
