/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Complete;


void InputEvent::preYouTubeTut(){
	g_robotDemo->fileName="transform-selection";
	g_robotDemo->function=InputEvent::youTubeTut;
	g_robotDemo->name="Create new file";
	robotDemoStart(setupSequence);
}
void InputEvent::youTubeTut(){

	const int seamless = 1;
	const int pelvis = 3;
	const int foreheadNP = 5;

	InputEvent* create_Skeleton_of_PartsArray[]={
		//new Section("section 0"),
		new Section("Create new file file"),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0001\\sound.wav"),
		new Wait(12),
		new ClickButton(openSmls),
		new SetFieldValue("filename", "t-piece.smls"),
		new ToggleField("open"),
		new ClickYes(),
		new MoveToNode(foreheadNP),
		new MoveToNode(foreheadNP + 9),
		new Wait(2),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0002\\sound.wav"),
new DragViewPos(.015,-.764999,0),
new DragViewRot(.780779,.624043,.030881,.910708, .015,-.764999),
new MouseZoom(1.61051, .015,-.764999),
new Wait(3),
////
//new Section("section 2"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0003\\sound.wav"),
new RectVert(-.85,.425,.889999,-.3425),
new Wait(6),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0004\\sound.wav"),
new VirtKeyDown(VK_LCONTROL),
new Wait(.25),
new TypeString("t"),
new VirtKeyUp(VK_LCONTROL),

new DecFieldX("translation",20),
new IncFieldX("translation",20),
new DecFieldY("translation",20),
new IncFieldY("translation",20),
new DecFieldZ("translation",20),
new IncFieldZ("translation",20),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0005\\sound.wav"),

new DecFieldX("rotation",20),
new IncFieldX("rotation",20),
new DecFieldY("rotation",20),
new IncFieldY("rotation",20),
new DecFieldZ("rotation",20),
new IncFieldZ("rotation",20),

new Section("bug"),
//new VirtKeyDown(VK_LCONTROL),
//new Wait(.25),
//new TypeString("t"),
//new VirtKeyUp(VK_LCONTROL),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0006\\sound.wav"),

new DecFieldX("scale",20),
new IncFieldX("scale",20),
new DecFieldY("scale",20),
new IncFieldY("scale",20),
new DecFieldZ("scale",20),
new IncFieldZ("scale",20),

new Wait(7),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0007\\sound.wav"),
new ClickButton(setFrontViewOrientation),
new TugCP(276,-1.934793,-.598984),
new TugCP(276,-.864794,.026016),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0008\\sound.wav"),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(.00693,-.652572,.110886)),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(.53693,.082428,.051161)),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0009\\sound.wav"),

new ClickButton(setLeftViewOrientation),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(-.01807,-.812572,.110886)),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(.53693,.082428,.110886)),
new ClickButton(setFrontViewOrientation),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0010\\sound.wav"),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.900844,.070956,-.000285)),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(-.270844,-.314044,-.000285)),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(-.400844,.070956,.110886)),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.024156,.100956,-.000285)),

//new Section("Scale"),
//new RectVert(-1,.35, 1,-.3425),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0011\\sound.wav"),

new Scale(276,-1.834793,-.598984),
//new TugCP(276,-.860905,.026344),
new Scale(276,-.864794,.026016),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.029156,-.044044,-.000285)),
new Scale(276,-1.834793,-.598984),
new Scale(276,-.864794,.026016),
new Wait(5),

//new Section("section 3"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0012\\sound.wav"),
new RectVert(-.95625,.290625,-.151251,-.221875),
new TugCP(172,-.36322,-.039079),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.196892,.067046,-.00024)),
new MoveToMultiSelectRotPoint(),
new Move3d(Vec3f(.148108,.907046,-.00024)),


//new Section("section 4"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0013\\sound.wav"),
new Wait(3),
new RectVert(.221875,.259375,.936874,-.205625),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.185204,.017046,0)),

new MovePointer3d(.913106,.026016),
new MovePointer3d(.185204,.017046),
new MovePointer3d(.913106,.026016),
new Wait(1),
new Stretch(429,.698106,-1.048983),
new Stretch(429,.913106,.026016),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0014\\sound.wav"),

new ToggleField("mirror"),
new SelectNodeByName("r_legNP"),
new ToggleField("mirror"),
new SelectNodeByName("crotchNP"),
new ToggleField("mirror"),
new SelectNodeByName("pelvisNP"),
new ToggleField("mirror"),
new Stretch(429,.698106,-1.048983),
new Stretch(429,.923106,.66101),
new Stretch(429,.913106,.026016),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0015\\sound.wav"),
new MoveToNode(foreheadNP + 9),
new MoveToNode(foreheadNP + 9 - 3),
new MoveToNode(foreheadNP + 9),
new Wait(12),
new MoveToNode(foreheadNP + 3),
new MoveToNode(foreheadNP),
new Wait(8),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0016\\sound.wav"),
new MovePointer3d(.185204,.017046),
new MovePointer3d(.913106,.026016),
new MovePointer3d(.185204,.017046),
new MovePointer3d(.913106,.026016),
new Stretch(429,.698106,-1.048983),
new Stretch(429,.698106,-1.048983),
new Stretch(435,.854717,-.980974),

		//new Section("Drag control points"),
		//
		//new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0001\\sound.wav"),
		//new Wait(3),

new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
