/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

extern const char* menu_delete;

extern const char* Create_a_New_Seamless_File;
extern const char* Complete;
extern const char* Build_a_box;

const char* str_spin="spin";



void InputEvent::preSwitchAnimIn3dDemo(){
	g_robotDemo->fileName="switch_anim";
	g_robotDemo->function=InputEvent::switchAnimIn3dDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::switchAnimIn3dDemo(){
	const int scene=0;
	const int seamless=1;
	const int r=1;
	int part1=seamless+2;
	int coneBuild=part1+1;
	int anim=coneBuild+2;
	int spinFunc=anim+1;
	int spinLine=spinFunc+1;
	int touchSensor=spinLine+1;
	int toggleFunc=touchSensor+1;
	int toggleLine=toggleFunc+1;

	InputEvent* eventArray[]={
		new Section("Create a new seamless file"),
		new ResizeSceneTreeWin(420+10, 660),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "switch_anim.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),
	};
	list+=EVENT_LIST(eventArray);
/////

	list+=new Section(Build_a_box);
	nameNode(part1, "p\n");
	list+=new ClickButton(buildBoxForSelPart);
	list+=new ToggleField("yCentred");
	list+=new ClickButton(toggleWireFrame),

	list+=new Section("Add Anim node");
	newNodeAsChild(ANIM, scene);
	nameNode(anim, str_spin);
	list+=new ToggleField("loop");
	list+=new ToggleField("play");
	list+=new IncFieldX("period", 3);
	list+=new Section("Add Function for Anim");
	newNodeAsChild(MEMBERFUNCTION, anim);
	list+=new Section("Add spin script");
	newNodeAsChild(CODELINE, spinFunc);
	//list+=new DragNewNodeBar(350, 260);
	nameNode(spinLine, "p.rotation=Rotation(0,0,1,PI*2*v)\n");
	list+=new Section("Add TouchSensor");
	list+=new SelectNode(scene);
	newNodeAsChild(TOUCHSENSOR, scene);
	list+=new Section("Add Function for TouchSensor");
	newNodeAsChild(MEMBERFUNCTION, touchSensor);
	list+=new Section("Add toggle Script");
	newNodeAsChild(CODELINE, toggleFunc);
	nameNode(toggleLine, "spin.pause=spin.play\n");

	InputEvent* eventArray7[]={
		new Section("Click box to switch off & on"),
		new Click3d(),
		new Wait(2),
		new Click3d(),
		new Wait(2),
		new Click3d(),
		new ClickButton(saveSmls),
	};
	list+=EVENT_LIST(eventArray7);

	part1++;
	anim++;
	spinFunc++;
	spinLine++;
	touchSensor++;
	toggleFunc++;
	int playLine=toggleLine+1;
	int remTimeLine=playLine+1;

	InputEvent* eventArray8[]={
		new Section("Add global variable to remember turn off time"),
		new NewNodeAsSiblingAbove(CODELINE, seamless),
		new SelectNode(r),
		new TypeString("double r=0\n"),
		new Section("Only switch on (don't toggle)"),
		new ReplacePartialCode(playLine, 5, 17, "play=true\n"),
		new Section("Save click time + 3 cycles of time"),
		new NewNodeAsChild(CODELINE, toggleFunc),
		new SelectNode(remTimeLine),
		new TypeString("r=getTime()+spin.period*3\n"),

		new Section("Add \"if\" statement"),
		new NewNodeAsSiblingAbove(CODELINE, spinLine),
		new SelectNode(spinLine),
		new TypeString("if(getTime()<r)\n"),
		new MoveNodeAsChild(spinLine+1, spinLine),
		new ClickButton(saveSmls),

		new Section("Click once to cycle 3 times"),
		new Click3d(),
		new Wait(12),

		new Section("Stop anim node too"),
		new MoveNodeAsChild(spinLine+1, spinFunc),
		new NewNodeAsChild(CODELINE, spinLine),
		new SelectNode(spinLine+1),
		new TypeString("spin.play=false"),
		//new Section("Change less than to greater than"),
		new ReplacePartialCode(spinLine, 13, 1, ">\n"),
		new ClickButton(saveSmls),
		new Click3d(),
		new Wait(12),
		new Section(Complete),
	};
	list+=EVENT_LIST(eventArray8);
}
//spin.play = !spin.play
//part1.rotation = Rotation(0, 0, 1, PI * 2 * v)