/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#define _WIN32_WINNT 0x0410


#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include"robot_aid.h"

extern const char* Create_a_New_Seamless_File;
extern const char* Replace_the_ColoreEffect_with_a_TextureEffect;
extern const char* Add_a_Stem_Node_to_the_Seamless_Node;
extern const char* Add_a_TextureMapper_Node_to_the_Stem_Node;
extern const char* Add_a_Surface_to_the_Stem;
extern const char* Increase_the_Number_of_Triangles;
extern const char* Shape_the_Triangle;
extern const char* Map_the_Whole_Texture_to_The_Triangles;
extern const char* Map_Only_the_Lower_Left_Quarter_of_the_Texture;
extern const char* Map_Only_the_Lower_Left_16th_of_the_Texture;
extern const char* Map_a_Different_16th_of_the_Texture;
extern const char* Map_2_16ths_of_the_Texture;
extern const char* Map_the_Top_Right_Quarter_of_the_Texture;
extern const char* Complete;

void InputEvent::preBuildTexturedObjectDemo(){
	g_robotDemo->fileName="build_textured_object";
	g_robotDemo->function=InputEvent::buildTexturedObjectDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::buildTexturedObjectDemo(){
	//const int scene=0;
	const int seamless=1;
	const int pelvis=3;
	const int nurbsLathe=4;
	const int torsoTextureMapper=nurbsLathe+2;

	InputEvent* eventArray[]={
		new Section("Create a new seamless file"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "build_textured_object.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),
	};
	list+=EVENT_LIST(eventArray);

	list+=new Section("Replace the ColoreEffect with a TextureEffect");

	newNodeAsReplacement(TEXTUREEFFECT, seamless+1);
	selNode(seamless+1);
	incGroupCount("url");
	setFieldValueNoShift("url", "simple_texture.png");

	list+=new Section("Add a NurbsLathe for the selected Part");
	selNode(pelvis);
	list+=new ClickButton(buildNurbsLatheForSelPart);
	clickButton(toggleWireFrame);
/*
	list+=new Section("Map the Whole Texture to The Triangles");
	list+=new ToggleField("clear");
	textureTile(Vec2i(0,0));
	textureTile(Vec2i(7,7));

//	list+=new IncButtonY(viewOrientation, 60);
*/
	list+=new DragViewRot(.1,1,0,PI),
	list+=new DragViewRot(0,1,.1,PI*2),

	list+=new Section("Map Only the Lower Left Quarter of the Texture");
	selNode(torsoTextureMapper);
	list+=new ToggleField("clear");
	textureTile(Vec2i(0,0));
	textureTile(Vec2i(3,3));

	list+=new DragViewRot(0,1,0,0),
	list+=new DragViewRot(.1,1,0,PI),
	list+=new DragViewRot(0,1,.1,PI*2),

	list+=new Section("Map Only the Lower Left 16th of the Texture");
	list+=new ToggleField("clear");
	textureTile(Vec2i(0,0));
	textureTile(Vec2i(1,1));


	list+=new DragViewRot(0,1,0,0),
	list+=new DragViewRot(.1,1,0,PI),
	list+=new DragViewRot(0,1,.1,PI*2),

	list+=new Section("Map a Different 16th of the Texture");
	list+=new ToggleField("clear");
	textureTile(Vec2i(2,0));
	textureTile(Vec2i(3,1));

	list+=new DragViewRot(0,1,0,0),
	list+=new DragViewRot(.1,1,0,PI),
	list+=new DragViewRot(0,1,.1,PI*2),

	list+=new Section("Map 2 16ths of the Texture");
	textureTile(Vec2i(0,0));

	list+=new DragViewRot(0,1,0,0),
	list+=new DragViewRot(.1,1,0,PI),
	list+=new DragViewRot(0,1,.1,PI*2),

	list+=new Section(Map_the_Top_Right_Quarter_of_the_Texture);
	list+=new ToggleField("clear");
	textureTile(Vec2i(4,4));
	textureTile(Vec2i(7,7));

	list+=new DragViewRot(0,1,0,0),
	list+=new DragViewRot(.1,1,0,PI),
	list+=new DragViewRot(0,1,.1,PI*2),

	clickButton(saveSmls);
	list+=new Section(Complete);
}