#include "seamless3d.h"
//g_bindSmlsFile contains the URL to our .smls file we want to bind to
String g_bindSmlsFile="C:\\Documents and Settings\\thyme\\My Documents\\Content\\techuelife_island_2_smls\\get_coord.smls";

//insert global variables here:
float LandCXZ = 100;

float LandTrans = 0;

int landStrips = 50;

float landSquareSize = 0;

int landEdgePntCnt = 0;

float halfLSS = 0;

float oneDivByLandSquareSize = 0;

class ScriptBind{//user definable class for binding nodes and containing script functions
public:
	//define node references to match nodes that will be found in the .smls file
	Seamless& peg;
	Seamless& peg2;
	Part& part2;
	Part& landPart;
	Stem& landStem;

	ScriptBind(//bind the nodes from the smls file to the ScriptBind class
		Seamless& i_peg,
		Seamless& i_peg2,
		Part& i_part2,
		Part& i_landPart,
		Stem& i_landStem
	):
	peg(i_peg),
	peg2(i_peg2),
	part2(i_part2),
	landPart(i_landPart),
	landStem(i_landStem)
{
	initialize();
}
void initialize(){//equivelent to initialize in vrml
//insert initialize code here
	LandTrans = LandCXZ * .5;
	landEdgePntCnt = landStrips + 1;
	landSquareSize = LandCXZ / landStrips;
	halfLSS = landSquareSize * .5;
	oneDivByLandSquareSize = 1 / landSquareSize;
}

float getLandHeight(float x, float z){
	float fx = (x + LandTrans);
	float fz = (LandTrans - z);
	float sqX = floor(fx / LandCXZ * landStrips);
	float sqZ = floor(fz / LandCXZ * landStrips);
	float modX = fx - sqX * landSquareSize;
	float modZ = fz - sqZ * landSquareSize;
	int lx = sqX;
	int lz = sqZ;
	lz = lz * landEdgePntCnt;
	int lz2 = lz + landEdgePntCnt;

	float bl = landPart.coord[lz + lx].y;
	float br = landPart.coord[lz + lx + 1].y;
	float tl = landPart.coord[lz2 + lx].y;
	float tr = landPart.coord[lz2 + lx + 1].y;

	if(modX < 2 - modZ){
		tr = br + (tl - bl);
		peg2.translation = Vec3f(landPart.coord[lz2 + lx + 1].x,tr,landPart.coord[lz2 + lx + 1].z);
	}
	else {
		bl = tl + (br - tr);
		peg2.translation = Vec3f(landPart.coord[lz + lx].x,bl,landPart.coord[lz + lx].z);
	}
	
	float by1 = bl + (tl - bl) * (modZ*oneDivByLandSquareSize);
	float by2 = br + (tr - br) * (modZ*oneDivByLandSquareSize);

	return by1 + (by2 - by1) * (modX*oneDivByLandSquareSize);
}

void onFrame(float v){//simulate Anim's onFrame (can add break point here and single step to check a point in time for the animation)
	Vec3f tran=peg.translation;
	tran.y=getLandHeight(tran.x, tran.z);
	peg.translation=tran;
}
//add user defined script functions here

}; //end ScriptBind class

NodePtr getNodeFromName(const String str);

ScriptBind* scriptBind=0;
void initializeDeveloperScript(){
	scriptBind = new ScriptBind(//new instance of ScriptBind binds the nodes to our script
		*dynamic_cast<Seamless*>(getNodeFromName("peg").p),
		*dynamic_cast<Seamless*>(getNodeFromName("peg2").p),
		*dynamic_cast<Part*>(getNodeFromName("part2").p),
		*dynamic_cast<Part*>(getNodeFromName("landPart").p),
		*dynamic_cast<Stem*>(getNodeFromName("landStem").p)
	);
}
void scriptBindAnimation(){
	float period = 1;
	scriptBind->onFrame(fmodf(g_time/period, period)); // create slider from period and pass as value
}