/* Seamless3d

Copyright (C) 2001-2013 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

void setPJTitleName();
void setCheckStates(ArtPtr pj);

//extern HWND hSceneTreeWnd;
void createActiveLabel();


#define titleStr "Seamless3d"
float getIncDecRes();
extern bool g_controlPanelOpen;
extern NodePtr g_setPtrForWindowRem;
void insertNodeAbove(int targetIndex, M_Node &mnode, NodePtr insertNode);
void insertNodeBelow(int targetIndex, M_Node &mnode, NodePtr insertNode);
//extern HWND hWndActiveCell;

void countAllSibNodes(int& sib, int& all);

class SelCount{
	int sib;
public:
	const int all;
	SelCount():
		all(1),
		sib(1)
	{}
	void operator ++(int);
	void operator --(int);
	void reset(){
		sib=1;
		*const_cast<int*>(&all)=1;
	}
	operator int ()const{
		return sib;
	}
	int SelCount::refreshAll(){
		countAllSibNodes(sib, *const_cast<int*>(&all));
		return all;
	}
};
extern SelCount g_selCount;
extern int g_copySibCount;
extern int g_copyAllCount;
int getNodeFlatLen(int listPos);
//int getPrevNodeFlatLen(int listPos);

extern int g_menuGroupIndex;

void setNodeWinTitleBar(Node* node);
NodePtr deepCopy(int& line);
//extern Node* g_activeCellNode;
bool nodeHasRouteTo(Node* from, Node* to);
void checkBackgroundColor(const String& str, int& i);
/*
extern Vec2i g_3dwinPos;
extern Vec2i g_3dwinSize;
extern Vec2i g_toolbarPos;
extern Vec2i g_toolbarSize;
extern Vec2i g_sceneTreePos;
extern Vec2i g_sceneTreeSize;
extern Vec2i g_nodeWinPos;
*/
enum SceneTreeConstants{
	treeLineColor = 0xc0c0c0,
	collapsedLineColor = 0xFF0000,
	pixSymbolCX = 16,
	pixSymbolCY = 16,
	tLnOffst = 11,
	nameOffset = pixSymbolCX - 1,
};

//#define ICON_LOOKUP_CX pixSymbolCY*11

void convertRoutesToScript(Seamless* smls);

void addNewNodeAsChild(Node* windowNode, unsigned fieldIdx, unsigned nodeType);
void addNewNodeAsSibling(Node* parent, unsigned fieldIdx, int element, unsigned nodeType, int dropWhere);
void replaceWithNewNode(Node* parent, unsigned fieldIdx, int element, unsigned nodeType);

void addCopyOfAsChild(Node* windowNode, unsigned fieldIdx, int copyNodeLine, int copySibCount);
void addCopyOfNodeAsSibling(int selNodeLine, int copyNodeLine, int copySibCount, int insertCopyofWhere);
void moveNodeAsChild(Node* selNode, int selFieldIdx, int selNodeLine, int copyNodeLine, int selCount, int copySibCount, int copyAllCount);
void replaceNodeWithMove(int selNodeLine, int copyNodeLine, int selCount, int copySibCount, int copyAllCount, int insertCopyofWhere);
void useNodeAsChild(Node* selNode, Node* copyNode, int selFieldIdx, int copyNodeLine, int selCount, int copySibCount);
void useSiblingNode(Node* selNode, int selNodeLine, int copyNodeLine, int selCount, int copySibCount, int type);

int getParent(int line);
void getFNodeElementForParent(int parentLine, int selLine, M_<SceneTreeListItem>& nodeList, int& fieldIdx, int& element );
int getLineForNonCollapsed(int collapsedLine);
/*
class Menu;
class Seperator{};
class MenuSim{
public:
	MenuSim():
		id(0),
		seperator(false),
		greyed(false),
		checked(false),
		createMenu(0)
	{}
	MenuSim(String i_str, CreateMenu* i_createMenu):
		str(i_str),
		id(0),
		seperator(false),
		greyed(false),
		checked(false),
		createMenu(i_createMenu)
	{}
	MenuSim(String i_str, int i_id, bool i_greyed=false, bool i_checked=false):
		str(i_str),
		id(i_id),
		seperator(false),
		greyed(i_greyed),
		checked(i_checked),
		createMenu(0)
	{}
	MenuSim(String i_str):
		str(i_str),
		id(0),
		seperator(false),
		greyed(false),
		checked(false),
		createMenu(0)
	{}
	MenuSim(Seperator&):
		id(0),
		seperator(true),
		greyed(false),
		checked(false),
		createMenu(0)
	{}
	String str;
	int id;
	bool seperator;
	bool checked;
	bool greyed;
	void buildMenu();
	CreateMenu* createMenu;
};
class MenuItem;
*/
bool getCollapsedLine(int nonCollapsedLine, int& collapsedLine);
void toggleWireFrame();

int getNodeLine(Node* node);
void removeNode(int i, M_Node &mnode, int ammount=1);
void getFolderPath(String& str, unsigned id);
void resetLooseEnds();
void updateBuild3dWindow(bool ifPartBuild=false);
int getLineByNodeName(String str);

enum DropWhere{
	DROP_ABOVE = 1,
	DROP_BELOW = 2,
	DROP_REPLACE = 3,
	DROP_CHILD = 4,
	DROP_SOURCE_CHILD = 5,
	DROP_DEST_CHILD = 6
};

Seamless* getSeamless(int& selLine);
Seamless* getSeamless2();
Seamless* getSeamless3(int& selLine);
GroupBuild* getGroup(NurbsPatch* patch);
Art* getGroupPart(NurbsPatch* patch);
Hair* getHair(int selLine);
Hair* getHair();
int getSeamless2Line();

